﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using IDTechSDK;

namespace VP3300_Demo
{
    class CommandInfo
    {
        public static string getCommandInfo(RETURN_CODE code)
        {
            switch ((int)code)
            {
                case 0: return "no error, beginning task";
                case 1: return "no response from reader";
                case 2: return "invalid response data";
                case 3: return "time out for task or CMD";
                case 4: return "wrong parameter";
                case 5: return "SDK is doing MSR or ICC task";
                case 6: return "SDK is doing PINPad task";
                case 7: return "SDK is doing CTLS task";
                case 8: return "SDK is doing EMV task";
                case 9: return "SDK is doing Other task";
                case 10: return "err response or data";
                case 11: return "no reader attached";
                case 12: return "mono audio is enabled";
                case 13: return "did connection";
                case 14: return "audio volume is too low";
                case 15: return "task or CMD be canceled";
                case 16: return "UF wrong string format";
                case 17: return "UF file not found";
                case 18: return "UF wrong file format";
                case 19: return "Attempt to contact online host failed";
                case 20: return "Attempt to perform RKI failed";
                case 0x300: return "Key Type(TDES) of Session Key is not same as the related Master Key.";
                case 0x400: return "Related Key was not loaded.";
                case 0x500: return "Key Same.";
                case 0x501: return "Key is all zero";
                case 0x502: return "TR-31 format error";
                case 0x702: return "PAN is Error Key.";
                case 0x705: return "No Internal MSR PAN (or Internal MSR PAN is erased timeout)";
                case 0X0C01: return "Incorrect Frame Tag";
                case 0X0C02: return "Incorrect Frame Type";
                case 0X0C03: return "Unknown Frame Type";
                case 0X0C04: return "Unknown Command";
                case 0X0C05: return "Unknown Sub-Command";
                case 0X0C06: return "CRC Error";
                case 0X0C07: return "Failed";
                case 0X0C08: return "Timeout";
                case 0X0C0A: return "Incorrect Parameter";
                case 0X0C0B: return "Command Not Supported";
                case 0X0C0C: return "Sub-Command Not Supported";
                case 0X0C0D: return "Parameter Not Supported / Status Abort Command";
                case 0X0C0F: return "Sub-Command Not Allowed";
                case 0X0D01: return "Incorrect Header Tag";
                case 0X0D02: return "Unknown Command";
                case 0X0D03: return "Unknown Sub-Command";
                case 0X0D04: return "CRC Error in Frame";
                case 0X0D05: return "Incorrect Parameter";
                case 0X0D06: return "Parameter Not Supported";
                case 0X0D07: return "Mal-formatted Data";
                case 0X0D08: return "Timeout";
                case 0X0D0A: return "Failed / NACK";
                case 0X0D0B: return "Command not Allowed";
                case 0X0D0C: return "Sub-Command not Allowed";
                case 0X0D0D: return "Buffer Overflow (Data Length too large for reader buffer)";
                case 0X0D0E: return "User Interface Event";
                case 0X0D11: return "Communication type not supported, VT-1, burst, etc.";
                case 0X0D12: return "Secure interface is not functional or is in an intermediate state.";
                case 0X0D13: return "Data field is not mod 8";
                case 0X0D14: return "Pad 0x80 not found where expected";
                case 0X0D15: return "Specified key type is invalid";
                case 0X0D1: return "Could not retrieve key from the SAM(InitSecureComm)";
                case 0X0D17: return "Hash code problem";
                case 0X0D18: return "Could not store the key into the SAM(InstallKey)";
                case 0X0D19: return "Frame is too large";
                case 0X0D1A: return "Unit powered up in authentication state but POS must resend the InitSecureComm command";
                case 0X0D1B: return "The EEPROM may not be initialized because SecCommInterface does not make sense";
                case 0X0D1C: return "Problem encoding APDU";
                case 0X0D20: return "Unsupported Index(ILM) SAM Transceiver error – problem communicating with the SAM(Key Mgr)";
                case 0X0D2: return "Unexpected Sequence Counter in multiple frames for single bitmap(ILM) Length error in data returned from the SAM(Key Mgr)";
                case 0X0D22: return "Improper bit map(ILM)";
                case 0X0D23: return "Request Online Authorization";
                case 0X0D24: return "ViVOCard3 raw data read successful";
                case 0X0D25: return "Message index not available(ILM) ViVOcomm activate transaction card type(ViVOcomm)";
                case 0X0D26: return "Version Information Mismatch(ILM)";
                case 0X0D27: return "Not sending commands in correct index message index(ILM)";
                case 0X0D28: return "Time out or next expected message not received(ILM)";
                case 0X0D29: return "ILM languages not available for viewing(ILM)";
                case 0X0D2A: return "Other language not supported(ILM)";
                case 0X0D41: return "Unknown Error from SAM";
                case 0X0D42: return "Invalid data detected by SAM";
                case 0X0D43: return "Incomplete data detected by SAM";
                case 0X0D44: return "Reserved";
                case 0X0D45: return "Invalid key hash algorithm";
                case 0X0D46: return "Invalid key encryption algorithm";
                case 0X0D47: return "Invalid modulus length";
                case 0X0D48: return "Invalid exponent";
                case 0X0D49: return "Key already exists";
                case 0X0D4A: return "No space for new RID";
                case 0X0D4B: return "Key not found";
                case 0X0D4C: return "Crypto not responding";
                case 0X0D4D: return "Crypto communication error";
                case 0X0D4E: return "Module-specific error for Key Manager";
                case 0X0D4F: return "All key slots are full (maximum number of keys has been installed)";
                case 0X0D50: return "Auto-Switch OK";
                case 0X0D51: return "Auto-Switch failed";
                case 0X0D90: return "Account DUKPT Key not exist";
                case 0X0D91: return "Account DUKPT Key KSN exausted";
                case 0x0D00: return "This Key had been loaded.";
                case 0x0E00: return "Base Time was loaded.";
                case 0x0F00: return "Encryption Or Decryption Failed.";
                case 0x1000: return "Battery Low Warning (It is High Priority Response while Battery is Low.)";
                case 0x1800: return "Send “Cancel Command” after send “Get Encrypted PIN” &”Get Numeric “& “Get Amount”";
                case 0x1900: return "Press “Cancel” key after send “Get Encrypted PIN” &”Get Numeric “& “Get Amount”";
                case 0x30FF: return "Security Chip is not connect";
                case 0x3000: return "Security Chip is deactivation & Device is In Removal Legally State.";
                case 0x3101: return "Security Chip is activation &  Device is In Removal Legally State.";
                case 0x5500: return "No Admin DUKPT Key.";
                case 0x5501: return "Admin  DUKPT Key STOP.";
                case 0x5502: return "Admin DUKPT Key KSN is Error.";
                case 0x5503: return "Get Authentication Code1 Failed.";
                case 0x5504: return "Validate Authentication Code Error.";
                case 0x5505: return "Encrypt or Decrypt data failed.";
                case 0x5506: return "Not Support the New Key Type.";
                case 0x5507: return "New Key Index is Error.";
                case 0x5508: return "Step Error.";
                case 0x5509: return "KSN Error";
                case 0x550A: return "MAC Error.";
                case 0x550B: return "Key Usage Error.";
                case 0x550C: return "Mode Of Use Error.";
                case 0x550F: return "Other Error.";
                case 0x6000: return "Save or Config Failed / Or Read Config Error.";
                case 0x6200: return "No Serial Number.";
                case 0x6900: return "Invalid Command";
                case 0x6A01: return "Unsupported Command In this State";
                case 0x6A00: return "Unsupported Command";
                case 0x6B00: return "Unknown parameter in command";
                case 0x6C00: return "Length parameter Error in command";
                case 0x7200: return "Device is suspend (MKSK suspend or press password suspend).";
                case 0x7300: return "PIN DUKPT is STOP (21 bit 1).";
                case 0x7400: return "Device is Busy.";
                case 0xE100: return "Can not enter sleep mode";
                case 0xE200: return "File has existed";
                case 0xE300: return "File has not existed";
                case 0xE313: return "IO line low -- Card error after session start";
                case 0xE400: return "Open File Error";
                case 0xE500: return "SmartCard Error";
                case 0xE600: return "Get MSR Card data is error";
                case 0xE700: return "Command time out";
                case 0xE800: return "File read or write is error";
                case 0xE900: return "Active 1850 error!";
                case 0xEA00: return "Load bootloader error";
                case 0xEF00: return "Protocol Error- STX or ETX or check error.";
                case 0xEB00: return "Picture is not exist";
                case 0x2C02: return "No Microprocessor ICC seated";
                case 0x2C06: return "no card seated to request ATR";
                case 0x2D01: return "Card Not Supported,";
                case 0x2D03: return "Card Not Supported, wants CRC";
                case 0x690D: return "Command not supported on reader without ICC support";
                case 0x8100: return "ICC error time out on power-up";
                case 0x8200: return "invalid TS character received - Wrong operation step";
                case 0x8300: return "Decode MSR Error";
                case 0x8400: return "TriMagII no Response";
                case 0x8500: return "No Swipe MSR Card";
                case 0x8510: return "No Financial Card";
                case 0x8600: return "Unsupported F, D, or combination of F and D";
                case 0x8700: return "protocol not supported EMV TD1 out of range";
                case 0x8800: return "power not at proper level";
                case 0x8900: return "ATR length too long";
                case 0x8B01: return "EMV invalid TA1 byte value";
                case 0x8B02: return "EMV TB1 required";
                case 0x8B03: return "EMV Unsupported TB1 only 00 allowed";
                case 0x8B04: return "EMV Card Error, invalid BWI or CWI";
                case 0x8B06: return "EMV TB2 not allowed in ATR";
                case 0x8B07: return "EMV TC2 out of range";
                case 0x8B08: return "EMV TC2 out of range";
                case 0x8B09: return "per EMV96 TA3 must be > 0xF";
                case 0x8B10: return "ICC error on power-up";
                case 0x8B11: return "EMV T=1 then TB3 required";
                case 0x8B12: return "Card Error, invalid BWI or CWI";
                case 0x8B13: return "Card Error, invalid BWI or CWI";
                case 0x8B17: return "EMV TC1/TB3 conflict*";
                case 0x8B20: return "EMV TD2 out of range must be T=1";
                case 0x8C00: return "TCK error";
                case 0xA304: return "connector has no voltage setting";
                case 0xA305: return "ICC error on power-up invalid (SBLK(IFSD) exchange";
                case 0xE301: return "ICC error after session start";
                case 0xFF00: return "Request to go online";
                case 0xFF01: return "EMV: Accept the offline transaction";
                case 0xFF02: return "EMV: Decline the offline transaction";
                case 0xFF03: return "EMV: Accept the online transaction";
                case 0xFF04: return "EMV: Decline the online transaction";
                case 0xFF05: return "EMV: Application may fallback to magstripe technology";
                case 0xFF06: return "EMV: ICC detected tah the conditions of use are not satisfied";
                case 0xFF07: return "EMV: ICC didn't accept transaction";
                case 0xFF08: return "EMV: Transaction was cancelled";
                case 0xFF09: return "EMV: Application was not selected by kernel or ICC format error or ICC missing data error";
                case 0xFF0A: return "EMV: Transaction is terminated";
                case 0xFF0B: return "EMV: Other EMV Error";
                case 0xFFFF: return "NO RESPONSE";
                case 0xF002: return "ICC communication timeout";
                case 0xF003: return "ICC communication Error";
                case 0xF00F: return "ICC Card Seated and Highest Priority, disable MSR work request";
                case 0xF200: return "AID List / Application Data is not exist";
                case 0xF201: return "Terminal Data is not exist";
                case 0xF202: return "TLV format is error";
                case 0xF203: return "AID List is full";
                case 0xF204: return "Any CA Key is not exist";
                case 0xF205: return "CA Key RID is not exist";
                case 0xF206: return "CA Key Index it not exist";
                case 0xF207: return "CA Key is full";
                case 0xF208: return "CA Key Hash Value is Error";
                case 0xF209: return "Transaction  format error";
                case 0xF20A: return "The command will not be processing";
                case 0xF20B: return "CRL is not exist";
                case 0xF20C: return "CRL number  exceed max number";
                case 0xF20D: return "Amount,Other Amount,Trasaction Type  are  missing";
                case 0xF20E: return "The Identification of algorithm is mistake";
                case 0xF20F: return "No Financial Card";
                case 0xF210: return "In Encrypt Result state, TLV total Length is greater than Max Length";
                case 0x1001: return "INVALID ARG";
                case 0x1002: return "FILE_OPEN_FAILED";
                case 0x1003: return "FILE OPERATION_FAILED";
                case 0x2001: return "MEMORY_NOT_ENOUGH";
                case 0x3002: return "SMARTCARD_FAIL";
                case 0x3003: return "SMARTCARD_INIT_FAILED";
                case 0x3004: return "FALLBACK_SITUATION";
                case 0x3005: return "SMARTCARD_ABSENT";
                case 0x3006: return "SMARTCARD_TIMEOUT";
                case 0x5001: return "EMV_PARSING_TAGS_FAILED";
                case 0x5002: return "EMV_DUPLICATE_CARD_DATA_ELEMENT";
                case 0x5003: return "EMV_DATA_FORMAT_INCORRECT";
                case 0x5004: return "EMV_NO_TERM_APP";
                case 0x5005: return "EMV_NO_MATCHING_APP";
                case 0x5006: return "EMV_MISSING_MANDATORY_OBJECT";
                case 0x5007: return "EMV_APP_SELECTION_RETRY";
                case 0x5008: return "EMV_GET_AMOUNT_ERROR";
                case 0x5009: return "EMV_CARD_REJECTED";
                case 0x5010: return "EMV_AIP_NOT_RECEIVED";
                case 0x5011: return "EMV_AFL_NOT_RECEIVED";
                case 0x5012: return "EMV_AFL_LEN_OUT_OF_RANGE";
                case 0x5013: return "EMV_SFI_OUT_OF_RANGE";
                case 0x5014: return "EMV_AFL_INCORRECT";
                case 0x5015: return "EMV_EXP_DATE_INCORRECT";
                case 0x5016: return "EMV_EFF_DATE_INCORRECT";
                case 0x5017: return "EMV_ISS_COD_TBL_OUT_OF_RANGE";
                case 0x5018: return "EMV_CRYPTOGRAM_TYPE_INCORRECT";
                case 0x5019: return "EMV_PSE_NOT_SUPPORTED_BY_CARD";
                case 0x5020: return "EMV_USER_SELECTED_LANGUAGE";
                case 0x5021: return "EMV_SERVICE_NOT_ALLOWED";
                case 0x5022: return "EMV_NO_TAG_FOUND";
                case 0x5023: return "EMV_CARD_BLOCKED";
                case 0x5024: return "EMV_LEN_INCORRECT";
                case 0x5025: return "CARD_COM_ERROR";
                case 0x5026: return "EMV_TSC_NOT_INCREASED";
                case 0x5027: return "EMV_HASH_INCORRECT";
                case 0x5028: return "EMV_NO_ARC";
                case 0x5029: return "EMV_INVALID_ARC";
                case 0x5030: return "EMV_NO_ONLINE_COMM";
                case 0x5031: return "TRAN_TYPE_INCORRECT";
                case 0x5032: return "EMV_APP_NO_SUPPORT";
                case 0x5033: return "EMV_APP_NOT_SELECT";
                case 0x5034: return "EMV_LANG_NOT_SELECT";
                case 0x5035: return "EMV_NO_TERM_DATA";
                case 0x6001: return "CVM_TYPE_UNKNOWN";
                case 0x6002: return "CVM_AIP_NOT_SUPPORTED";
                case 0x6003: return "CVM_TAG_8E_MISSING";
                case 0x6004: return "CVM_TAG_8E_FORMAT_ERROR";
                case 0x6005: return "CVM_CODE_IS_NOT_SUPPORTED";
                case 0x6006: return "CVM_COND_CODE_IS_NOT_SUPPORTED";
                case 0x6007: return "NO_MORE_CVM";
                case 0x6008: return "PIN_BYPASSED_BEFORE";
                case 0x7001: return "PK_BUFFER_SIZE_TOO_BIG";
                case 0x7002: return "PK_FILE_WRITE_ERROR";
                case 0x7003: return "PK_HASH_ERROR";
                case 0x8001: return "NO_CARD_HOLDER_CONFIRMATION";
                case 0x8002: return "GET_ONLINE_PIN";
                case 0xD000: return "Data not exist";
                case 0xD001: return "Data access error";
                case 0xD100: return "RID not exist";
                case 0xD101: return "RID existed";
                case 0xD102: return "Index not exist";
                case 0xD200: return "Maximum exceeded";
                case 0xD201: return "Hash error";
                case 0xD205: return "System Busy";
                case 0x0E01: return "Unable to go online";
                case 0x0E02: return "Technical Issue";
                case 0x0E03: return "Declined";
                case 0x0E04: return "Issuer Referral transaction";
                case 0x0F01: return "Decline the online transaction";
                case 0x0F02: return "Request to go online";
                case 0x0F03: return "Transaction is terminated";
                case 0x0F05: return "Application was not selected by kernel or ICC format error or ICC missing data error";
                case 0x0F07: return "ICC didn't accept transaction";
                case 0x0F0A: return "Application may fallback to magstripe technology";
                case 0x0F0C: return "Transaction was cancelled";
                case 0x0F0D: return "Timeout";
                case 0x0F0F: return "Other EMV Error";
                case 0x0F10: return "Accept the offline transaction";
                case 0x0F11: return "Decline the offline transaction";
                case 0x0F21: return "ICC detected tah the conditions of use are not satisfied";
                case 0x0F22: return "No app were found on card matching terminal configuration";
                case 0x0F23: return "Terminal file does not exist";
                case 0x0F24: return "CAPK file does not exist";
                case 0x0F25: return "CRL Entry does not exist";
                case 0x0FFE: return "Return code when blocking is disabled";
                case 0x0FFF: return "Return code when command is not applicable on the selected device";
                case 0xF005: return "ICC Encrypted C-APDU Data Structure Length Error Or Format Error.";
            }
            return "";
        }
    }
}
